<div class="card">
  <p-table
    #dt
    styleClass="custom-gridlines"
    [value]="data"
    [paginator]="paginator"
    [rows]="rows"
    [totalRecords]="totalRecords"
    [lazy]="lazy"
    [rowHover]="true"
    [globalFilterFields]="globalFilterFields"
    (onPage)="onPageChange($event)"
    (onSort)="onSort($event)"
  >
    <ng-template pTemplate="caption">
      <div class="flex justify-content-between align-items-center">
        <p-calendar
          *ngIf="visibleDateRangeFilter"
          [(ngModel)]="rangeDates"
          [showIcon]="true"
          [showButtonBar]="true"
          [view]="'date'"
          [selectionMode]="'range'"
          [minDate]="today"
          [placeholder]="'Zeitraum auswählen'"
          (onClose)="onDateRangeChange()"
          (onClear)="onDateRangeChange()"
        ></p-calendar>
        <div *ngIf="visibleSearch" class="p-input-icon-left">
          <i class="pi pi-search"></i>
          <input
            pInputText
            type="text"
            (input)="onGlobalFilter($event, dt)"
            placeholder="Suche..."
          />
        </div>

        <p-dropdown
          *ngIf="filterOptions.length > 0"
          [options]="filterOptions"
          [(ngModel)]="selectedFilter"
          placeholder="Filter"
          (onChange)="onFilterChange()"
        >
        </p-dropdown>

        <urbo-cms-ui-create-button
          *ngIf="createButtonClick.observed"
          [permission]="createPermission"
          (create)="createButtonClick.emit()"
          style="align-self: flex-end"
        >
        </urbo-cms-ui-create-button>
      </div>
    </ng-template>
    <ng-template pTemplate="header">
      <tr>
        <th
          id="header"
          *ngFor="let col of columns"
          [pSortableColumn]="col.sortable ? col.field : ''"
        >
          {{ col.header }}
          <p-sortIcon *ngIf="col.sortable" [field]="col.field"></p-sortIcon>
        </th>
        <th
          id="actions"
          *ngIf="
            view.observed ||
            edit.observed ||
            delete.observed ||
            customActionTemplate
          "
        >
          Actions
        </th>
      </tr>
    </ng-template>

    <ng-template pTemplate="body" let-rowData>
      <tr>
        <td *ngFor="let col of columns">
          <ng-container *ngIf="col.type === 'link'; else defaultCell">
            <a
              [href]="rowData[col.field]"
              title="Open Link"
              target="_blank"
              class="url-cell"
              pTooltip="{{ rowData[col.field] }}"
              tooltipPosition="top"
            >
              <i class="pi pi-external-link icon-link"></i>
            </a>
          </ng-container>
          <ng-template #defaultCell>
            <span
              [urboCmsUiTableCellRenderer]="col.type"
              [rowData]="rowData"
              [field]="col.field"
            ></span>
          </ng-template>
        </td>
        <td
          *ngIf="
            view.observed ||
            edit.observed ||
            delete.observed ||
            customActionTemplate
          "
        >
          <div
            class="flex flex-nowrap justify-content-start align-items-center"
          >
            <urbo-cms-ui-view-button
              *ngIf="view.observed"
              [data]="rowData"
              [permission]="viewPermission"
              (view)="view.emit($event)"
            >
            </urbo-cms-ui-view-button>

            <urbo-cms-ui-highlight-button
              *ngIf="highlight.observed"
              [data]="rowData"
              [permission]="highlightPermission"
              (highlight)="highlight.emit($event)"
            >
            </urbo-cms-ui-highlight-button>

            <urbo-cms-ui-edit-button
              *ngIf="edit.observed"
              [data]="rowData"
              [permission]="editPermission"
              (edit)="edit.emit($event)"
            >
            </urbo-cms-ui-edit-button>

            <urbo-cms-ui-delete-button
              *ngIf="delete.observed"
              [data]="rowData"
              [permission]="deletePermission"
              (delete)="delete.emit($event)"
            >
            </urbo-cms-ui-delete-button>

            <ng-container *ngIf="customActionTemplate">
              <ng-container
                *ngTemplateOutlet="
                  customActionTemplate;
                  context: { $implicit: rowData }
                "
              >
              </ng-container>
            </ng-container>
          </div>
        </td>
      </tr>
    </ng-template>
  </p-table>
</div>
